<?php
// If it's going to need the database, then it's 
// probably smart to require it before we start.
require_once('config.php');
require_once('database.php');
require_once('session.php');


class Attendance extends DatabaseObject {
	
	protected static $table_name="attendance_1";
	protected static $db_fields = array('id', 'emp_code', 'type', 'lat', 'lon', 'accuracy', 'msg', 'status', 'att_type', 'att_status', 'status_action', 'dev_distance', 'location_address', 'updated_by', 'updated_at', '_date', '_time');
	
	public $id;
	public $emp_code;
	public $type;
	public $lat;
	public $lon;
	public $accuracy;
	public $msg;
	public $status;
	public $att_type;
	public $att_status;
	public $status_action;
	public $dev_distance;
	public $location_address;
	public $updated_by;
	public $updated_at;
	public $_date;
	public $_time;
	
	public static function last_attendance($date, $emp_code, $table_name) {
		$result_array = self::find_by_sql("SELECT * FROM ".$table_name." WHERE emp_code='{$emp_code}' AND _date='{$date}' order by id DESC LIMIT 1");
		return !empty($result_array) ? array_shift($result_array) : false;
	}
	
	
	public static function authenticate_attendance_seg1($date, $emp_code, $type, $table_name) {
		$result_array = self::find_by_sql("SELECT * FROM ".$table_name." WHERE emp_code='{$emp_code}' AND  type='{$type}' AND _date='{$date}' order by id DESC LIMIT 1");
		return !empty($result_array) ? array_shift($result_array) : false;
	}
	
	
	public static function authenticate_attendance($date, $emp_code, $table_name) {
		$result_array = self::find_by_sql("SELECT * FROM ".$table_name." WHERE emp_code='{$emp_code}' AND _date='{$date}' order by id DESC LIMIT 1");
		return !empty($result_array) ? array_shift($result_array) : false;
	}
	
	
	public static function authenticate($username="", $password="", $table_name) {
		global $database;
		$username = $database->escape_value($username);
		$password = $database->escape_value($password);
	
		$sql  = "SELECT * FROM ".$table_name;
		$sql .= " WHERE username = '{$username}' ";
		$sql .= "AND password = '{$password}' ";
		$sql .= "LIMIT 1";
		$result_array = self::find_by_sql($sql);
		return !empty($result_array) ? array_shift($result_array) : false;
	}
	
	public static function email_authenticate($email, $table_name) {
		global $database;
	  	$sql = "SELECT COUNT(*) FROM ".$table_name." where email = '{$email}'";
	  	$result_set = $database->query($sql);
	  	$row = $database->fetch_array($result_set);
      	return array_shift($row);
	}
	
	public static function authenticate_mobile($mobile, $table_name) {
		$result_array = self::find_by_sql("SELECT * FROM ".$table_name." WHERE mobile='{$mobile}' LIMIT 1");
		return !empty($result_array) ? array_shift($result_array) : false;
	}
	
	
	
	
	
	
	// Common Database Methods
	public static function find_all($table_name) {
		return self::find_by_sql("SELECT * FROM ".$table_name."  order by id DESC");
  	}
	  
	public static function find_by_id($id=0, $table_name) {
		$result_array = self::find_by_sql("SELECT * FROM ".$table_name." WHERE id={$id} LIMIT 1");
		return !empty($result_array) ? array_shift($result_array) : false;
	}
	
	public static function find_by_emp_code($emp_code, $limit, $table_name) {
	    if($limit > 0 ){
		    return self::find_by_sql("SELECT *  FROM ".$table_name." WHERE emp_code='{$emp_code}' Order by id DESC LIMIT {$limit}");
	    } else {
		    return self::find_by_sql("SELECT *  FROM ".$table_name." WHERE emp_code='{$emp_code}' Order by id DESC");
	    }
	}
  
  	public static function find_by_last_id($table_name) {
		$result_array = self::find_by_sql("SELECT id  FROM ".$table_name." Order by id DESC LIMIT 1");
		return !empty($result_array) ? array_shift($result_array) : false;
  	}
    
  	public static function find_by_sql($sql="") {
		global $database;
		$result_set = $database->query($sql);
		$object_array = array();
		while ($row = $database->fetch_array($result_set)) {
		  $object_array[] = self::instantiate($row);
		}
		return $object_array;
  	}
	
	public static function count_by_bpid($id, $table_name) {
	  	global $database;
	  	$sql = "SELECT COUNT(*) FROM ".$table_name." Where bp_code = '{$id}' ";
    	$result_set = $database->query($sql);
		$row = $database->fetch_array($result_set);
    	return array_shift($row);
	}
	
	public static function count_all($table_name) {
	  global $database;
	  $sql = "SELECT COUNT(*) FROM ".$table_name." ";
      $result_set = $database->query($sql);
	  $row = $database->fetch_array($result_set);
    return array_shift($row);
	}
	
	public static function count_status($status, $table_name) {
	  global $database;
	  $sql = "SELECT COUNT(*) FROM ".$table_name." WHERE status = '".$status."'";
      $result_set = $database->query($sql);
	  $row = $database->fetch_array($result_set);
    return array_shift($row);
	}
	

	private static function instantiate($record) {
		// Could check that $record exists and is an array
    $object = new self;
		// Simple, long-form approach:
		// $object->id 				= $record['id'];
		// $object->username 	= $record['username'];
		// $object->password 	= $record['password'];
		// $object->first_name = $record['first_name'];
		// $object->last_name 	= $record['last_name'];
		
		// More dynamic, short-form approach:
		foreach($record as $attribute=>$value){
		  if($object->has_attribute($attribute)) {
		    $object->$attribute = $value;
		  }
		}
		return $object;
	}
	
	private function has_attribute($attribute) {
	  // We don't care about the value, we just want to know if the key exists
	  // Will return true or false
	  return array_key_exists($attribute, $this->attributes());
	}

	protected function attributes() { 
		// return an array of attribute names and their values
	  $attributes = array();
	  foreach(self::$db_fields as $field) {
	    if(property_exists($this, $field)) {
	      $attributes[$field] = $this->$field;
	    }
	  }
	  return $attributes;
	}
	
	protected function sanitized_attributes() {
	  global $database;
	  $clean_attributes = array();
	  // sanitize the values before submitting
	  // Note: does not alter the actual value of each attribute
	  foreach($this->attributes() as $key => $value){
	    $clean_attributes[$key] = $database->escape_value($value);
	  }
	  return $clean_attributes;
	}
	
	public function save($attendance_table_name) {
	  // A new record won't have an id yet.
	  return isset($this->id) ? $this->update($attendance_table_name) : $this->create($attendance_table_name);
	}
	
	public function create($table_name) {
		global $database;
		// Don't forget your SQL syntax and good habits:
		// - INSERT INTO table (key, key) VALUES ('value', 'value')
		// - single-quotes around all values
		// - escape all values to prevent SQL injection
		$attributes = $this->sanitized_attributes();
	  $sql = "INSERT INTO ".$table_name." (";
		$sql .= join(", ", array_keys($attributes));
	  $sql .= ") VALUES ('";
		$sql .= join("', '", array_values($attributes));
		$sql .= "')";
	  if($database->query($sql)) {
	    $this->id = $database->insert_id();
	    return true;
	  } else {
	    return false;
	  }
	}

	public function update($table_name) {
	  global $database;
		// Don't forget your SQL syntax and good habits:
		// - UPDATE table SET key='value', key='value' WHERE condition
		// - single-quotes around all values
		// - escape all values to prevent SQL injection
		$attributes = $this->sanitized_attributes();
		$attribute_pairs = array();
		foreach($attributes as $key => $value) {
		  $attribute_pairs[] = "{$key}='{$value}'";
		}
		$sql = "UPDATE ".$table_name." SET ";
		$sql .= join(", ", $attribute_pairs);
		$sql .= " WHERE id=". $database->escape_value($this->id);
	  $database->query($sql);
	  return ($database->affected_rows() == 1) ? true : false;
	}

	public function delete($table_name) {
		global $database;
		// Don't forget your SQL syntax and good habits:
		// - DELETE FROM table WHERE condition LIMIT 1
		// - escape all values to prevent SQL injection
		// - use LIMIT 1
	  $sql = "DELETE FROM ".$table_name." ";
	  $sql .= " WHERE id=". $database->escape_value($this->id);
	  $sql .= " LIMIT 1";
	  $database->query($sql);
	  return ($database->affected_rows() == 1) ? true : false;
	
		// NB: After deleting, the instance of User still 
		// exists, even though the database entry does not.
		// This can be useful, as in:
		//   echo $user->first_name . " was deleted";
		// but, for example, we can't call $user->update() 
		// after calling $user->delete().
	}

}

?>